//
//  MenuCell.m
//  iShaker
//
//  Created by mike on 07/01/2009.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "MenuComboCell.h"
#import "MenuConstants.h"
#import "MenuViewController.h"
#import "MenuComboListViewController.h"

@implementation MenuComboCell

@synthesize items = _items;

-(id) initWithReuseIdentifier:(NSString *)reuseIdentifier {
  return [self initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:reuseIdentifier];
}

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
	self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
  if (self) {
    self.textLabel.textAlignment = NSTextAlignmentLeft;
    self.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    self.detailTextLabel.backgroundColor = [UIColor clearColor];
    self.detailTextLabel.textColor = kMenuHeaderTextColor;
  }
  return self;
}

-(void)dealloc {
  DLog(@"dealloc %@", [self class]);
  self.items = nil;
  [super dealloc];
}

-(void) loadWithDictionary:(NSDictionary*)dictionary menu:(MenuViewController*)menu {
  [super loadWithDictionary:dictionary menu:menu];
  
  // check if the combo values are specifeid in an array inside of the plist
  NSArray* items = [dictionary valueForKey:MenuItemItems];
  NSString* plistName = [dictionary valueForKey:MenuItemPlist];
  NSString* keyName = [dictionary valueForKey:MenuItemKey];
  
  if (items) {
  
  // check if the combo values are specifeid in a separate plist
  } else if (plistName) {
    NSString *path=[[NSBundle mainBundle] pathForResource:plistName ofType:@"plist"];
    items = [[[NSArray alloc] initWithContentsOfFile:path] autorelease];
  
  // check if the combo values are specified in the menu's value store
  } else if (keyName) {
    items = [MenuViewController valueForKey:keyName];
  
  // check if the combo values are specifeid in userDefault
  } else {
    //NSString* userDefault = [dictionary valueForKey:MenuItemUserDefault];
  }

  self.items = items;
}

- (void)execute {
  MenuComboListViewController* comboListViewController = [[MenuComboListViewController alloc] init];
  comboListViewController.comboCell = self;
  comboListViewController.items = self.items;
  comboListViewController.userDefaultName = self.userDefaultName;
  comboListViewController.title = self.textLabel.text;
  if (changeTarget && changeSelector) {
    [comboListViewController setTarget:changeTarget selector:changeSelector];
  }
  
  if ([MenuViewController navigationController]) {
    [[MenuViewController navigationController] pushViewController:comboListViewController animated:YES];
  } else {
    DLog(@"MenuViewController navigationController is not set");
  }
  
  [comboListViewController release];
}

-(void) setValue:(id)value {
  self.detailTextLabel.text = [MenuViewController itemTitle:value];
  
  if (actionTarget && actionSelector) {
    [actionTarget performSelector:actionSelector withObject:value];
  }
}

@end
