//
//  MainMenuViewController.h
//  iShaker
//
//  Created by mike on 05/01/2009.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>

@class MenuCell;

@interface MenuViewController : UITableViewController {
  NSDictionary* _menu;
  id _delegate;
}

@property (nonatomic, retain) NSDictionary* menu;
@property (nonatomic, assign) id delegate;

+(void) setNavigationController:(UINavigationController*)controller;
+(UINavigationController*) navigationController;
+(NSString*) stringForMenu:(NSDictionary*)menu key:(NSString*)key;
+(UIColor *) colorFromHexString:(NSString *)hexString;

/*
 * Customize the look
 */
 
+(void) setBackgroundImage:(UIImage*)image;
+(void) setCellImageTop:(UIImage*)top
             topPressed:(UIImage*)topPressed
                 middle:(UIImage*)middle
          middlePressed:(UIImage*)middlePressed
                 bottom:(UIImage*)bottom
          bottomPressed:(UIImage*)bottomPressed
                 single:(UIImage*)single
          singlePressed:(UIImage*)singlePressed;
+(void) setCellTitleFont:(UIFont*)font;
+(void) setCellTitleColor:(UIColor*)color;
+(void) setCellTitleShadowColor:(UIColor*)color;
+(void) setCellTitleShadowOffset:(CGSize)offset;

/*
 * Use Key-Value store for dynamically modified data which is used e.g. to store
 * the list of items in a combo menu.
 */
 
+(void) setValue:(id)value forKey:(NSString*)key;
+(id) valueForKey:(NSString*)key;

-(id) initWithPlist:(NSString*)plistName;
-(void) tableView:(UITableView *)tableView customizeCellBackground:(UITableViewCell*)cell indexPath:(NSIndexPath*)indexPath;
-(void) customizeCellTitle:(MenuCell*)cell;

@end
